//+------------------------------------------------------------------+
//|                                                     Euro-Rev.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#import "EUR_Rev.dll"
   int ValueGet00(int a0, int a1, int a2, int a3, int a4, string a5);
   int ValueGet01(int a0, int a1, int a2, int a3, int a4);
   int ValueGetSet(int a0, int a1, int a2, int a3);
#import

extern string InfoSetAggressiveness = "1:Very, 2:More, 3:OK, 4:Slow";
extern int Aggressiveness = 4;
extern int TimeRange = 5;
extern int MaxTrades = 5;
extern string ExtentionPair = "";
extern string InfoLot = "==== Money Management ====";
extern double Lots = 0.1;
extern bool MM_on = FALSE;
extern double RiskPercentage = 5.0;
extern double MaxLotSize = 0.0;
double gda_140[50];
int gia_148[50];
int TrailingSL;
int gia_156[7];
int HardSL;
int Magic = 67776;
string EAName = "EUR-REV";

//+------------------------------------------------------------------+
//| Expert Start Function                                            |
//+------------------------------------------------------------------+

int start() {
   l300394930468750c367898cb667bac();
   l300394930468750972d792e274fd86(gia_148);
   gia_148[0] = TimeCurrent();
   l30039493046875061da7238b30c07b(gia_148);
   int li_0 = l3003949304687504760b4f49061fea(gia_148);
   l300394930468750a984a45016655d1(gda_140);
   gda_140[0] = Bid;
   if (HardSL != 0) l300394930468750c0eac833bd4de73();
   if (Ask - Bid > ValueGetSet(6, Aggressiveness, Digits, gia_156[6]) * Point) return (0);
   if (l3003949304687506d14cdd6c3563f6() < MaxTrades) l3003949304687502f7e72786eb5bdd(gda_140, ValueGetSet(1, Aggressiveness, Digits, gia_156[6]), li_0);
   return (0);
}

//+------------------------------------------------------------------+
//| Expert Initialization Function                                   |
//+------------------------------------------------------------------+

int init() {
   l300394930468750b934ead934e26b4();
   HardSL = ValueGetSet(4, Aggressiveness, Digits, gia_156[6]);
   TrailingSL = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if (TrailingSL > HardSL && HardSL != 0) {
      HardSL = TrailingSL;
      Print("Your TrailingStop now is:" + TrailingSL);
   }
   return (0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit() {
   ObjectsDeleteAll(0, OBJ_LABEL);
   ObjectsDeleteAll(0, OBJ_TEXT);
   l300394930468750a5edcf35ca9d976();
   return (0);
}

void l300394930468750c0eac833bd4de73() {
   double ld_0;
   int stoplevel_8 = HardSL;
   for (int pos_12 = 0; pos_12 < OrdersTotal(); pos_12++) {
      if (OrderSelect(pos_12, SELECT_BY_POS) != FALSE) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() >= Magic && OrderMagicNumber() <= Magic) {
               if (OrderType() == OP_BUY) {
                  ld_0 = Bid - Point * stoplevel_8;
                  if (!(OrderStopLoss() < ld_0 && OrderOpenPrice() < ld_0)) continue;
                  l3003949304687509bb1722e93457cd(ld_0, OrderTicket());
                  continue;
               }
               ld_0 = Ask + Point * stoplevel_8;
               if (OrderStopLoss() > ld_0 && OrderOpenPrice() > ld_0) l3003949304687509bb1722e93457cd(ld_0, OrderTicket());
            }
         }
      }
   }
}

void l3003949304687509bb1722e93457cd(double a_price_0, int a_ticket_8) {
   TrailingSL = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if (OrderModify(a_ticket_8, OrderOpenPrice(), a_price_0, OrderTakeProfit(), 0, Red) == -1) Print("Error:" + GetLastError() + " OrderType:" + OrderType() + " Ticket:" + OrderTicket());
}

void l30039493046875061da7238b30c07b(int &aia_0[50]) {
   int arr_size_4 = ArraySize(aia_0);
   int li_8 = TimeCurrent() - (aia_0[l3003949304687504760b4f49061fea(aia_0) - 1]);
   while (li_8 > TimeRange) {
      aia_0[l3003949304687504760b4f49061fea(aia_0) - 1] = 0;
      li_8 = TimeCurrent() - (aia_0[l3003949304687504760b4f49061fea(aia_0) - 1]);
      if (l3003949304687504760b4f49061fea(aia_0) < 2) break;
   }
}

int l3003949304687504760b4f49061fea(int aia_0[50]) {
   int arr_size_4 = ArraySize(aia_0);
   for (int index_8 = 0; index_8 < arr_size_4; index_8++)
      if (!(aia_0[index_8] > 0)) return (index_8);
   return (arr_size_4 - 1);
}

void l300394930468750a984a45016655d1(double &ada_0[50]) {
   int li_4 = ArraySize(ada_0);
   for (int li_8 = li_4; li_8 > 0; li_8--) ada_0[li_8] = ada_0[li_8 - 1];
   ada_0[0] = 0;
}

void l300394930468750972d792e274fd86(int &aia_0[50]) {
   int li_4 = ArraySize(aia_0);
   for (int li_8 = li_4; li_8 > 0; li_8--) aia_0[li_8] = aia_0[li_8 - 1];
   aia_0[0] = 0;
}

void l3003949304687502f7e72786eb5bdd(double ada_0[50], int ai_4, int ai_8) {
   double lots_12;
   double ld_20 = ada_0[ArrayMaximum(ada_0, ai_8)] - ada_0[ArrayMinimum(ada_0, ai_8)];
   if (ld_20 > ai_4 * Point) {
      if (MM_on) lots_12 = l30039493046875056539919aa25836();
      else lots_12 = Lots;
      if (Bid == ada_0[ArrayMaximum(ada_0, ai_8)]) l300394930468750db6c1bfbacb7e82(ValueGetSet(2, Aggressiveness, Digits, gia_156[6]), ValueGetSet(3, Aggressiveness, Digits, gia_156[6]), lots_12, OP_BUY);
      if (Bid == ada_0[ArrayMinimum(ada_0, ai_8)]) l300394930468750db6c1bfbacb7e82(ValueGetSet(2, Aggressiveness, Digits, gia_156[6]), ValueGetSet(3, Aggressiveness, Digits, gia_156[6]), lots_12, OP_SELL);
   }
}

int l3003949304687506d14cdd6c3563f6() {
   int li_ret_0;
   for (int pos_4 = 0; pos_4 < OrdersTotal(); pos_4++) {
      if (OrderSelect(pos_4, SELECT_BY_POS) != FALSE) {
         if (OrderSymbol() == Symbol())
            if (OrderMagicNumber() >= Magic && OrderMagicNumber() <= Magic) li_ret_0++;
      }
   }
   return (li_ret_0);
}

void l300394930468750b934ead934e26b4() {
   bool li_0 = FALSE;
   if (Symbol() == "EURUSD" + ExtentionPair) li_0 = TRUE;
   for (int li_4 = 1; li_4 <= 5; li_4++) gia_156[li_4] = ValueGet00(li_4, IsDemo(), IsTesting(), IsDllsAllowed(), li_0, EAName);
   gia_156[1] = 11;
   gia_156[2] = 22;
   gia_156[6] = ValueGet01(gia_156[1], gia_156[2], gia_156[3], gia_156[4], gia_156[5]);
}

int l300394930468750db6c1bfbacb7e82(int ai_0, int ai_4, double a_lots_8, int a_cmd_16) {
   int li_20;
   double price_24;
   double price_32;
   double price_40;
   int datetime_48;
   if (a_cmd_16 % 2 == 0) {
      if (a_cmd_16 == OP_BUYLIMIT) price_24 = Ask + li_20 * Point;
      else price_24 = Ask + li_20 * Point;
      if (ai_4 != 0) price_32 = price_24 - (ai_4 + li_20) * Point;
      if (ai_0 != 0) price_40 = price_24 + (ai_0 + li_20) * Point;
      datetime_48 = -1;
   }
   if (a_cmd_16 % 2 == 1) {
      if (a_cmd_16 == OP_SELLLIMIT) price_24 = Bid + li_20 * Point;
      else price_24 = Bid + li_20 * Point;
      if (ai_4 != 0) price_32 = price_24 - ((-ai_4) - li_20) * Point;
      if (ai_0 != 0) price_40 = price_24 - (ai_0 - li_20) * Point;
      datetime_48 = -1;
   }
   OrderSend(Symbol(), a_cmd_16, a_lots_8, price_24, ValueGetSet(5, Aggressiveness, Digits, gia_156[6]), price_32, price_40, EAName, Magic, datetime_48);
   return (0);
}

double l30039493046875056539919aa25836() {
   double ld_0 = Lots;
   if (MM_on) ld_0 = l300394930468750d331c2df6bd4b5e(MathAbs(RiskPercentage));
   if (ld_0 > MaxLotSize && MaxLotSize != 0.0) ld_0 = MaxLotSize;
   ld_0 = l3003949304687504261842a0e55f62(ld_0);
   return (ld_0);
}

double l300394930468750d331c2df6bd4b5e(double ad_0) {
   bool li_8 = TRUE;
   double minlot_12 = MarketInfo(Symbol(), MODE_MINLOT);
   double ld_20 = MarketInfo(Symbol(), MODE_LOTSIZE) / AccountLeverage();
   double ld_28 = ad_0 / 100.0 * AccountBalance() / ld_20;
   double ld_ret_36 = MathFloor(ld_28);
   while (li_8) {
      ld_ret_36 += minlot_12;
      if (ld_ret_36 > ld_28) {
         li_8 = FALSE;
         ld_ret_36 -= minlot_12;
      }
   }
   return (ld_ret_36);
}

double l3003949304687504261842a0e55f62(double ad_0) {
   if (ad_0 > MarketInfo(Symbol(), MODE_MAXLOT)) ad_0 = MarketInfo(Symbol(), MODE_MAXLOT);
   else
      if (ad_0 < MarketInfo(Symbol(), MODE_MINLOT)) ad_0 = MarketInfo(Symbol(), MODE_MINLOT);
   return (ad_0);
}

void l30039493046875086c43548db42558(string a_name_0, int a_corner_8, int a_y_12, int a_fontsize_16, color a_color_20, string a_text_24) {
   if (ObjectFind(a_name_0) != 0) {
      ObjectCreate(a_name_0, OBJ_LABEL, 0, 0, 0);
      ObjectSet(a_name_0, OBJPROP_CORNER, a_corner_8);
      ObjectSet(a_name_0, OBJPROP_XDISTANCE, 10);
      ObjectSet(a_name_0, OBJPROP_YDISTANCE, a_y_12);
   }
   ObjectSetText(a_name_0, a_text_24, a_fontsize_16, "Arial Bold", a_color_20);
}

void l300394930468750c367898cb667bac() {
   double ld_0;
   Comment("\nEA on Server: ", AccountServer(), " | Account Leverage: 1:", AccountLeverage(), 
   "\nStopOut Level: ", AccountStopoutLevel(), "% | ModeStopLevel: " + DoubleToStr(MarketInfo(Symbol(), MODE_STOPLEVEL), 0) + " point");
   l30039493046875086c43548db42558("Dat1", 1, 40, 14, White, "Price: " + DoubleToStr(Bid, Digits) + " / " + DoubleToStr(Ask, Digits));
   if (AccountMargin() == 0.0) ld_0 = 0;
   else ld_0 = 100.0 * (AccountEquity() / AccountMargin());
   l30039493046875086c43548db42558("D1", 2, 30, 11, Orange, "Free margin [Balance]: " + DoubleToStr(ld_0, 2) + "% [" + DoubleToStr(AccountBalance(), 2) + "]");
   l30039493046875086c43548db42558("D2", 2, 10, 11, LightGreen, "Equity: " + DoubleToStr(AccountEquity(), 2));
   l30039493046875086c43548db42558("Time", 3, 40, 16, LightGreen, TimeToStr(TimeCurrent(), TIME_MINUTES|TIME_SECONDS));
}

void l300394930468750a5edcf35ca9d976() {
   string ls_0 = "a";
   string ls_8 = "b";
   string ls_16 = ls_0 + ls_8;
}
//+------------------------------------------------------------------+