
#property copyright "turimix"
#property link      ""

double gda_76[50];
int gia_80[50];
extern int pipsense = 100;
extern int timerange = 5;
extern int MaxTrades = 5;
extern int TP = 500; //50 pips 5 digit
extern int SL = 120; //12 pips
extern int TrailingStop = 30;
extern bool Use_ECN = TRUE;
extern double maxspread = 40.0;
extern int slippage = 10;
extern int magic = 67776;
bool gi_128 = TRUE; //Log Errors
int gi_132 = -1;
int g_stoplevel_136;
extern string autolot = "==== Automatic Lots ====";
extern double Lots = 0.1;
extern bool AutoLotSize = FALSE;
extern double RiskPercentage = 5.0;
extern double MaxAllowedLotSize = 0.0;

int init() {
   g_stoplevel_136 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if (g_stoplevel_136 > TrailingStop && TrailingStop != 0) {
      TrailingStop = g_stoplevel_136;
      Print("Your TrailingStop now is:" + g_stoplevel_136);
   }
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   string ls_0;
   string ls_8;
   string ls_16;
   if (!IsTesting() || IsVisualMode()) {
      ls_8 = "TURIMIX EA is running on your account.";
      if (Digits == 3 || Digits == 5) ls_0 = "Spread is= " + DoubleToStr((Ask - Bid) / Point / 10.0, 1) + " pips ";
      if (Digits == 4) ls_0 = "Spread is= " + DoubleToStr((Ask - Bid) / Point, 1) + " pips ";
      ls_16 = "Account Balance=" + DoubleToStr(AccountBalance(), 2);
      Comment("\n" 
         + ls_8 
         + "\n" 
         + ls_0 
         + "\n" 
         + ls_16 
      + "\n");
   }
   timearray(gia_80);
   gia_80[0] = TimeCurrent();
   timefilter(gia_80);
   int li_24 = index(gia_80);
   trailingarray(gda_76);
   gda_76[0] = Bid;
   if (TrailingStop != 0) controllauscita();
   if (Ask - Bid > maxspread * Point) {
      Comment("\n SPREAD IS TOO HIGH ...");
      Print("SPREAD IS TOO HIGH ...");
      return (0);
   }
   if (contaitrade() < MaxTrades) priceaction(gda_76, pipsense, li_24);
   return (0);
}

void controllauscita() {
   double ld_0;
   int li_8 = TrailingStop;
   for (int l_pos_12 = 0; l_pos_12 < OrdersTotal(); l_pos_12++) {
      if (OrderSelect(l_pos_12, SELECT_BY_POS) != FALSE) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() >= magic && OrderMagicNumber() <= magic) {
               if (OrderType() == OP_BUY) {
                  ld_0 = Bid - Point * li_8;
                  if (OrderStopLoss() < ld_0 && OrderOpenPrice() < Bid - li_8 * Point) ModifySL(ld_0, OrderTicket());
               } else {
                  ld_0 = Ask + Point * li_8;
                  if (OrderStopLoss() > ld_0 && OrderOpenPrice() > Ask + li_8 * Point) ModifySL(ld_0, OrderTicket());
               }
            }
         }
      }
   }
}

void ModifySL(double a_price_0, int a_ticket_8) {
   g_stoplevel_136 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if (OrderModify(a_ticket_8, OrderOpenPrice(), a_price_0, OrderTakeProfit(), 0, Red) == -1)
      if (gi_128) LogError();
}

void timefilter(int &aia_0[50]) {
   int l_arr_size_4 = ArraySize(aia_0);
   int li_8 = TimeCurrent() - (aia_0[index(aia_0) - 1]);
   while (li_8 > timerange) {
      aia_0[index(aia_0) - 1] = 0;
      li_8 = TimeCurrent() - (aia_0[index(aia_0) - 1]);
      if (index(aia_0) < 2) break;
   }
}

int index(int aia_0[50]) {
   int l_arr_size_4 = ArraySize(aia_0);
   for (int l_index_8 = 0; l_index_8 < l_arr_size_4; l_index_8++)
      if (!(aia_0[l_index_8] > 0)) return (l_index_8);
   return (l_arr_size_4 - 1);
}

void trailingarray(double &ada_0[50]) {
   int l_arr_size_4 = ArraySize(ada_0);
   for (int li_8 = l_arr_size_4; li_8 > 0; li_8--) ada_0[li_8] = ada_0[li_8 - 1];
   ada_0[0] = 0;
}

void timearray(int &aia_0[50]) {
   int l_arr_size_4 = ArraySize(aia_0);
   for (int li_8 = l_arr_size_4; li_8 > 0; li_8--) aia_0[li_8] = aia_0[li_8 - 1];
   aia_0[0] = 0;
}

void priceaction(double ada_0[50], int ai_4, int ai_8) {
   double l_lots_12;
   double ld_20 = ada_0[ArrayMaximum(ada_0, ai_8)] - ada_0[ArrayMinimum(ada_0, ai_8)];
   if (ld_20 > ai_4 * Point) {
      if (AutoLotSize) l_lots_12 = lotsize();
      else l_lots_12 = Lots;
      if (Bid == ada_0[ArrayMaximum(ada_0, ai_8)]) {
         Print("I saw price go up: pip movement: " + (ld_20 / Point) + " in " + ((TimeCurrent() - (gia_80[index(gia_80) - 1]))) + " seconds.");
         SendTrade(TP, SL, l_lots_12, OP_BUY);
      }
      if (Bid == ada_0[ArrayMinimum(ada_0, ai_8)]) {
         Print("I saw price go down: pip movement: " + (ld_20 / Point) + " in " + ((TimeCurrent() - (gia_80[index(gia_80) - 1]))) + " seconds.");
         SendTrade(TP, SL, l_lots_12, OP_SELL);
      }
   }
}

int contaitrade() {
   int li_ret_0;
   for (int l_pos_4 = 0; l_pos_4 < OrdersTotal(); l_pos_4++) {
      if (OrderSelect(l_pos_4, SELECT_BY_POS) != FALSE) {
         if (OrderSymbol() == Symbol())
            if (OrderMagicNumber() >= magic && OrderMagicNumber() <= magic) li_ret_0++;
      }
   }
   return (li_ret_0);
}

int SendTrade(int ai_0, int ai_4, double a_lots_8, int a_cmd_16, int ai_20 = 0) {
   int li_24;
   double l_price_28;
   double l_price_36;
   double l_price_44;
   color l_color_52;
   string ls_56 = "TURIMIXEAV4";
   if (a_cmd_16 % 2 == 0) {
      if (a_cmd_16 == OP_BUYLIMIT) l_price_28 = Ask + li_24 * Point;
      else l_price_28 = Ask + li_24 * Point;
      if (ai_4 != 0) l_price_36 = l_price_28 - (ai_4 + li_24) * Point;
      if (ai_0 != 0) l_price_44 = l_price_28 + (ai_0 + li_24) * Point;
      l_color_52 = CLR_NONE;
   }
   if (a_cmd_16 % 2 == 1) {
      if (a_cmd_16 == OP_SELLLIMIT) l_price_28 = Bid + li_24 * Point;
      else l_price_28 = Bid + li_24 * Point;
      if (ai_4 != 0) l_price_36 = l_price_28 - ((-ai_4) - li_24) * Point;
      if (ai_0 != 0) l_price_44 = l_price_28 - (ai_0 - li_24) * Point;
      l_color_52 = CLR_NONE;
   }
   double l_price_64 = l_price_36;
   double l_price_72 = l_price_44;
   if (Use_ECN) l_price_36 = 0;
   if (Use_ECN) l_price_44 = 0;
   int l_ticket_80 = OrderSend(Symbol(), a_cmd_16, a_lots_8, l_price_28, slippage, l_price_36, l_price_44, ls_56 + "-" + Symbol() + "-" + magic, magic + ai_20, 0, l_color_52);
   int l_bool_84 = OrderSelect(l_ticket_80, SELECT_BY_TICKET);
   if (l_bool_84 == TRUE) OrderModify(OrderTicket(), OrderOpenPrice(), l_price_64, l_price_72, 0, Blue);
   return (0);
}

double lotsize() {
   double ld_0 = Lots;
   if (AutoLotSize) ld_0 = autoLots(MathAbs(RiskPercentage));
   if (ld_0 > MaxAllowedLotSize && MaxAllowedLotSize != 0.0) ld_0 = MaxAllowedLotSize;
   ld_0 = lotzone(ld_0);
   return (ld_0);
}

double autoLots(double ad_0) {
   bool li_8 = TRUE;
   double l_minlot_12 = MarketInfo(Symbol(), MODE_MINLOT);
   double ld_20 = MarketInfo(Symbol(), MODE_LOTSIZE) / AccountLeverage();
   double ld_28 = ad_0 / 100.0 * AccountBalance() / ld_20;
   double ld_ret_36 = MathFloor(ld_28);
   while (li_8) {
      ld_ret_36 += l_minlot_12;
      if (ld_ret_36 > ld_28) {
         li_8 = FALSE;
         ld_ret_36 -= l_minlot_12;
      }
   }
   return (ld_ret_36);
}

double lotzone(double ad_0) {
   if (ad_0 > MarketInfo(Symbol(), MODE_MAXLOT)) ad_0 = MarketInfo(Symbol(), MODE_MAXLOT);
   else
      if (ad_0 < MarketInfo(Symbol(), MODE_MINLOT)) ad_0 = MarketInfo(Symbol(), MODE_MINLOT);
   return (ad_0);
}

void LogError() {
   string ls_0;
   if (gi_128) {
      if (gi_132 > 0) {
         ls_0 = "Error:" + GetLastError() + " OrderType:" + OrderType() + " Ticket:" + OrderTicket();
         ls_0 = TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES|TIME_SECONDS) + " " + ls_0;
         FileWrite(gi_132, ls_0);
      }
   }
}